import { Label, ShapeCircle, ShapeRect, ShapeRectNew } from "./Unit";

export class Letter{
    data;

    images;

    bgColor;

    lineColor;

    scaleX = 1;

    scaleY = 1;

    bg : ShapeRectNew;

    dW;

    canDrag = true;


    init(images, data, bgColor, scaleX = 1, scaleY = 1) {

        this.images = images;

        this.data = data;

        this.bgColor = bgColor;

        this.scaleX = scaleX;

        this.scaleY = scaleY;

        this.initBg();

        let letter = this.initView();
  
        let w = 20 * this.scaleX + letter.getBoundingBox().width;

        let h = 59 * this.scaleY;

        this.bg.setSize(w, h, 0);
        letter.x = w / 2;
        letter.y = h / 2;
    }

    initBg(){

        let bg = new ShapeRectNew();
        bg.fillColor = this.bgColor;

        this.bg = bg;

    }

    initView(){
        const letter = new Label();
        letter.text = this.data.val;
        letter.textAlign = 'center';
        letter.fontSize = 36;
        letter.fontName = "GOTHICB";
        letter.fontColor = "#facf46";
        letter.setScaleXY(this.scaleX);
        letter.refreshSize();
        this.bg.addChild(letter);

        return letter;
    }
}